<?php

class Octo
{
    private $DB = null;

    function __construct($DB)
    {
        $this->BD = $DB;
    }

    public function InsertOredr($Get = null)
    {
        $this->CreateTable();
        $this->BD->sql = "INSERT INTO `{TABLE_PREFIX}octo_s_state` (`code`, `name`) VALUES
							('created', 'Транзакция успешно создана'),
                            ('canceled', 'Транзакция отменена'),
                            ('succeeded', 'Транзакция успешно завершена')";
        $this->BD->query();

        $this->BD->sql = "INSERT INTO {TABLE_PREFIX}octo_transactions VALUES
							(Null, :octo_uuid, :p_octo_time, NOW(), NOW(), null, :p_amount, 'created', :p_order_id, :p_cms_order_id, :p_is_flag_test)";

        $this->BD->param(':octo_uuid', $Get['octo_uuid']);

        $this->BD->param(':p_octo_time', time());

        $this->BD->param(':p_amount', $Get['Amount']);

        $this->BD->param(':p_order_id', is_null($Get['OrderId']) ? 0 : $Get['OrderId']);

        $this->BD->param(':p_cms_order_id', is_null($Get['CmsOrderId']) ? 0 : $Get['CmsOrderId']);
        $this->BD->param(':p_is_flag_test', $Get['IsFlagTest']);

        $this->BD->query();
        return false;
    }


    public function CreateTable(){
        $SqlList = $this->ScanFile("/Install_Bd/");

        if(!is_null($SqlList))
        {
            foreach($SqlList as $k=>$v)
            {
                $this->BD->sql = $v;
                $Param = $this->BD->query();
            }
        }
    }

    private function ScanFile($BasePath)
    {
        $FileList = null;
        $dir = opendir(__DIR__.$BasePath);
        $i=0;
        while($file = readdir($dir))
        {
            if (($file != ".") && ($file != "..")) {
                if(is_file(__DIR__.$BasePath.$file))
                {
                    $FileList[] = file_get_contents(__DIR__.$BasePath.$file);
                }
            }
        }
        closedir($dir);

        return $FileList;
    }
}

?>