<?php

class OctoCallback{
    private $BD = null;
    private $Octo = null;
    public $Get = null;
    function __construct($db_group){
        $DbConnect = false;
        if (extension_loaded('mysqli') and !$DbConnect){$DbConnect=true; $this->BD = new DbMySqli($db_group);}
        if (extension_loaded('pdo') and !$DbConnect){$DbConnect=true; $this->BD = new MySql($db_group); }
        if (extension_loaded('mysql') and !$DbConnect){$DbConnect=true; $this->BD = new MySql($db_group);}
        $this->Octo = new Octo($this->BD);

    }
    public function getUUID($order_id){
        $this->BD->sql = "SELECT octo_transaction_id FROM {TABLE_PREFIX}octo_transactions WHERE order_id = :order_id AND cms_order_id = :order_id";
        $this->BD->param(':order_id', $order_id);
        $res = $this->BD->query();
        return $res->fetch()->octo_transaction_id;
    }

    public function confirmOrder($order_id, $octo_uuid){
        $this->BD->sql = "UPDATE {TABLE_PREFIX}order SET order_status_id = :p_state WHERE order_id = :p_cms_order_id";
        $this->BD->param(':p_state', 5);
        $this->BD->param(':p_cms_order_id', $order_id);
        if($this->BD->query()){
            $this->BD->sql = "UPDATE {TABLE_PREFIX}octo_transactions SET state = :state WHERE order_id = :order_id AND octo_transaction_id = :octo_uuid";
            $this->BD->param(':state', 'succeeded');
            $this->BD->param(':order_id', $order_id);
            $this->BD->param(':octo_uuid', $octo_uuid);
            if($this->BD->query()){
                return true;
            }
        }else{
            return false;
        }
    }

    public function checkOrder($order_id, $octo_id){
        $this->BD->sql = "SELECT order_id FROM {TABLE_PREFIX}order WHERE order_id = :order_id";
        $this->BD->param(':order_id', $order_id);
        $tempRes = $this->BD->query();
        $res = $tempRes->fetch();
        if(!$res) {return false;}
        $this->BD->sql = "SELECT octo_transaction_id FROM {TABLE_PREFIX}octo_transactions WHERE order_id = :order_id AND cms_order_id = :order_id";
        $this->BD->param(':order_id', $order_id);
        $this->BD->param(':p_cms_order_id', $order_id);
        $octores = $this->BD->query();
        $octoId =  $octores->fetch()->octo_transaction_id;
        if($octo_id === $octoId){
            return true;
        }
        else{
            return false;
        }
    }
}
?>